--- programs/uninstaller/main.c.old	2007-04-24 14:51:15.000000000 -0500
+++ programs/uninstaller/main.c	2007-04-24 12:58:13.000000000 -0500
@@ -263,6 +263,11 @@
             WaitForSingleObject(info.hProcess, INFINITE);
             res = GetExitCodeProcess(info.hProcess, &exit_code);
             WINE_TRACE("%d: %08x\n", res, exit_code);
+            /* If the program's uninstaller did not remove the registry entry, remove it */
+            RegOpenKeyExW(entries[i].rootkey, PathUninstallW, 0, KEY_READ, &hkeyUninst);
+            if (RegDeleteKeyW(hkeyUninst, entries[i].key) == ERROR_SUCCESS)
+                WINE_TRACE("Deleted key: %s\n", wine_dbgstr_w(entries[i].key));
+            RegCloseKey(hkeyUninst);
         }
         else
         {
